#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ZscoreSeriesNode {
    #[builder(custom(type = super::NumericSeriesNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::NumericSeriesNode>,
    #[builder(default, into)]
    #[serde(rename = "groupByTags", skip_serializing_if = "Option::is_none", default)]
    group_by_tags: Option<std::collections::BTreeSet<String>>,
    #[builder(custom(type = super::AlignmentConfiguration, convert = Box::new))]
    #[serde(rename = "alignmentConfiguration")]
    alignment_configuration: Box<super::AlignmentConfiguration>,
}
impl ZscoreSeriesNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        input: super::NumericSeriesNode,
        alignment_configuration: super::AlignmentConfiguration,
    ) -> Self {
        Self::builder()
            .input(input)
            .alignment_configuration(alignment_configuration)
            .build()
    }
    #[inline]
    pub fn input(&self) -> &super::NumericSeriesNode {
        &*self.input
    }
    #[inline]
    pub fn group_by_tags(&self) -> Option<&std::collections::BTreeSet<String>> {
        self.group_by_tags.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn alignment_configuration(&self) -> &super::AlignmentConfiguration {
        &*self.alignment_configuration
    }
}
